//+------------------------------------------------------------------+
//|                                           JurikFastKStoch_v1.mq4 |
//|                                Copyright  2009, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
// List of Prices:
// Price    = 0 - Close  
// Price    = 1 - Open  
// Price    = 2 - High  
// Price    = 3 - Low  
// Price    = 4 - Median Price   = (High+Low)/2  
// Price    = 5 - Typical Price  = (High+Low+Close)/3  
// Price    = 6 - Weighted Close = (High+Low+Close*2)/4
// Price    = 7 - Heiken Ashi Close  
// Price    = 8 - Heiken Ashi Open
// Price    = 9 - Heiken Ashi High
// Price    =10 - Heiken Ashi Low

#property copyright "Copyright  2009, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  SkyBlue
#property indicator_width1  1
#property indicator_maximum 100
#property indicator_minimum 0

//---- 
extern int     TimeFrame         =   0;   //Time Frame in min
extern int     Price             =   0;   //Price Mode (0...10)
extern int     Sto_Period        =  14;   //Period of Stochastic
extern int     Smooth            =  10;   //Period of Jurik Smoothing (or K%)
extern double  Phase             =   0;   //-100...100
extern int     SmoothMode        =   0;   //0-final smoothing,1- 1st pre-smoothing,2-2nd pre-smoothing,3-without pre-smoothing
extern double  OverBought        =  70;   //OverBought Level (ex.70)
extern double  OverSold          =  30;   //OverSold Level (ex.30)
//---- 
double JSto[];
//----
double tmp[][5];
double haClose[], haOpen[], haHigh[], haLow[];
int    draw_begin, pBars, mcnt_bars; 
string short_name;
double len, len1, len2, pow1, bet, R;
double blen, blen1, blen2, bpow1, bbet;
int    AvgLen = 65;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- 
   SetIndexStyle(0,DRAW_LINE);
   
   if(TimeFrame == 0 || TimeFrame < Period()) TimeFrame = Period();
     
   draw_begin=AvgLen*TimeFrame/Period();
//---- 
   switch(TimeFrame)
   {
   case 1     : string TF = "M1"; break;
   case 5     : TF = "M5"; break;
   case 15    : TF = "M15"; break;
   case 30    : TF = "M30"; break;
   case 60    : TF = "H1"; break;
   case 240   : TF ="H4"; break;
   case 1440  : TF="D1"; break;
   case 10080 : TF="W1"; break;
   case 43200 : TF="MN1"; break;
   default    : TF="Current";
   } 
   short_name = "JurikFastKStoch_v1 ["+TF+"] ("+Price+","+Sto_Period+","+Smooth+","+DoubleToStr(Phase,1)+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Fast K");
   
   SetIndexDrawBegin(0,draw_begin);
//---- 
   SetIndexBuffer(0,JSto);
//----
   blen = 0.5*(Sto_Period - 1);
   
   blen1 = MathLog(MathSqrt(blen))/MathLog(2.0) + 2;
	if (blen1 < 0) blen1 = 0;
 	
	bpow1 = blen1 - 2;
	if (bpow1 < 0.5) bpow1 = 0.5;
    
	blen2 = MathSqrt(blen)*blen1;
    
	bbet = blen2/(blen2 + 1);
//----	
	len = 0.5*(Smooth - 1);
   R = 0.01*Phase + 1.5;
   len1 = MathLog(MathSqrt(len))/MathLog(2.0) + 2;
	if (len1 < 0) len1 = 0;
 	
	pow1 = len1 - 2;
	if (pow1 < 0.5) pow1 = 0.5;
    
	len2 = MathSqrt(len)*len1;
    
	bet = len2/(len2 + 1);     
//----
   SetLevelValue(0,OverBought);
   SetLevelStyle(STYLE_DOT,1,Gray);
   SetLevelValue(1,OverSold);
   SetLevelStyle(STYLE_DOT,1,Gray);
//---- 
   return(0);
}
//+------------------------------------------------------------------+
//| JurikFastKStoch_v1                                               |
//+------------------------------------------------------------------+
int start()
{
   int limit, y, i, shift, cnt_bars=IndicatorCounted(); 
   double bsmax[], bsmin[], bVolty[], bAvgVolty[], bSum[];
   double smax[], smin[], Volty[], AvgVolty[], Sum[], mJSto[];
   
   double price, hiprice[], loprice[], K[];
      
   if(TimeFrame!=Period()) int mBars = iBars(NULL,TimeFrame); else mBars = Bars; 
   if(mBars != pBars)
   {
   ArrayResize(hiprice,mBars);
   ArrayResize(loprice,mBars);
   ArrayResize(bsmin,mBars);
   ArrayResize(bsmax,mBars);
   ArrayResize(bAvgVolty,mBars);
   ArrayResize(bVolty,mBars); 
   ArrayResize(bSum,mBars);
   ArrayResize(smin,mBars);
   ArrayResize(smax,mBars);
   ArrayResize(AvgVolty,mBars);
   ArrayResize(Volty,mBars); 
   ArrayResize(Sum,mBars);
   ArrayResize(K,mBars); 
   ArrayResize(mJSto,mBars);
   ArrayResize(tmp,mBars);     
      if(Price > 6 && Price <= 10)
      {
      ArrayResize(haClose,mBars);
      ArrayResize(haOpen,mBars);
      ArrayResize(haHigh,mBars);
      ArrayResize(haLow,mBars);
      }
  
   pBars = mBars;
   }  
   
   if(cnt_bars<1)
   {
   for(i=Bars-1;i>0;i--)  JSto[i]=EMPTY_VALUE; 
   mcnt_bars = 0;
   }
//---- 
   if(mcnt_bars > 0) mcnt_bars--;
   
   for(y=mcnt_bars;y<mBars;y++)
   {
      if(Price <= 6)
      { 
      price = iMA(NULL,TimeFrame,1,0,0,Price,mBars-y-1); 
      hiprice[y] = iMA(NULL,TimeFrame,1,0,0,2,mBars-y-1);   
      loprice[y] = iMA(NULL,TimeFrame,1,0,0,3,mBars-y-1);
      }
      else
      if(Price > 6 && Price <= 10) 
      {
      price = HeikenAshi(TimeFrame,Price-7,mBars-y-1);
      hiprice[y] = HeikenAshi(TimeFrame,2,mBars-y-1);
      loprice[y] = HeikenAshi(TimeFrame,3,mBars-y-1);
      }
   
      double hi = 0;      
      double lo = 10000000000;
      
      for(i = 0;i < Sto_Period; i++)
      {   
      hi = MathMax(hi,hiprice[y-i]);
      lo = MathMin(lo,loprice[y-i]);
      }
      
      if(y <= Sto_Period) {bsmax[y] = hi; bsmin[y] = lo;}
      else
      {  
	 	double bdel1 = hi - bsmax[y-1];
      double bdel2 = lo - bsmin[y-1];
		
         if(MathAbs(bdel1) > MathAbs(bdel2)) bVolty[y] = MathAbs(bdel1); 
         else 
	      if(MathAbs(bdel1) < MathAbs(bdel2)) bVolty[y] = MathAbs(bdel2);
	      else
	      if(MathAbs(bdel1) == MathAbs(bdel2)) bVolty[y] = 0;
		
      bSum[y] = bSum[y-1] + 0.1*(bVolty[y] - bVolty[y-10]);
	   
      if(y <= AvgLen+1) bAvgVolty[y] = bAvgVolty[y-1] + 2.0*(bSum[y] - bAvgVolty[y-1])/(AvgLen+1);	    
      else
		bAvgVolty[y] = SMA(bSum,AvgLen,y);
	         
      if (bAvgVolty[y] > 0) double bdVolty = bVolty[y]/bAvgVolty[y];
	   if (bdVolty > MathPow(blen1,1.0/bpow1)) bdVolty = MathPow(blen1,1.0/bpow1);
      if (bdVolty < 1) bdVolty = 1.0;
	   
	   double bpow2 = MathPow(bdVolty, bpow1);
      double bKv = MathPow(bbet, MathSqrt(bpow2));		
	
      if (bdel1 > 0) bsmax[y] = hi; else bsmax[y] = hi - bKv*bdel1;
      if (bdel2 < 0) bsmin[y] = lo; else bsmin[y] = lo - bKv*bdel2;
	   
      if(bsmax[y] - bsmin[y] > 0) K[y] = 100*(price - bsmin[y])/(bsmax[y] - bsmin[y]); else K[y] = 0;       
//----
      double del1 = K[y] - smax[y-1];
      double del2 = K[y] - smin[y-1];
		
         if(MathAbs(del1) > MathAbs(del2)) Volty[y] = MathAbs(del1); 
         else 
	      if(MathAbs(del1) < MathAbs(del2)) Volty[y] = MathAbs(del2);
	      else
	      if(MathAbs(del1) == MathAbs(del2)) Volty[y] = 0;
		
      Sum[y] = Sum[y-1] + 0.1*(Volty[y] - Volty[y-10]);
	   
      if(y <= AvgLen+1) AvgVolty[y] = AvgVolty[y-1] + 2.0*(Sum[y] - AvgVolty[y-1])/(AvgLen+1);	    
      else
		AvgVolty[y] = SMA(Sum,AvgLen,y);
	         
      if (AvgVolty[y] > 0) double dVolty = Volty[y]/AvgVolty[y];
	   if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
      if (bdVolty < 1) bdVolty = 1.0;
	   
	   double pow2 = MathPow(dVolty, pow1);
      double Kv = MathPow(bet, MathSqrt(pow2));		
	
      if (del1 > 0) smax[y] = K[y]; else smax[y] = K[y] - Kv*del1;
      if (del2 < 0) smin[y] = K[y]; else smin[y] = K[y] - Kv*del2;        
      
         
      mJSto[y] = JSmooth(SmoothMode,K[y], Smooth, pow2, 0, y);   
      
      if(TimeFrame == Period()) JSto[mBars-y-1] = mJSto[y];
      }
   mcnt_bars = mBars-1;
   }
   
   if(TimeFrame > Period())
   { 
   if(cnt_bars>0) cnt_bars--;
   limit = Bars-cnt_bars+TimeFrame/Period()-1;
      
      for(shift=0,y=0;shift<limit;shift++)
      {
      if (Time[shift] < iTime(NULL,TimeFrame,y)) y++; 
      JSto[shift] = mJSto[mBars-y-1];
      }
   }
   return(0);
}

// JSmooth - Smoothing by Mark Jurik
double JSmooth(int mode,double price,int per,double pow,int num,int bar)
{
   double beta = 0.45*(per-1)/(0.45*(per-1)+2);
	double alpha = MathPow(beta,pow);
	
	if(bar <= Sto_Period + 1) {tmp[bar][num+4] = price; tmp[bar][num] = price; tmp[bar][num+2] = price;}
	else 
   if(bar > Sto_Period + 1) 
   {
	tmp[bar][num]   = (1-alpha)*price + alpha*tmp[bar-1][num];
	tmp[bar][num+1] = (price - tmp[bar][num])*(1-beta) + beta*tmp[bar-1][num+1];
	tmp[bar][num+2] = tmp[bar][num] + R*tmp[bar][num+1];
	if (mode == 3) tmp[bar][num+2] = price; 
	tmp[bar][num+3] = (tmp[bar][num+2] - tmp[bar-1][num+4])*MathPow((1-alpha),2) + MathPow(alpha,2)*tmp[bar-1][num+3];
	tmp[bar][num+4] = tmp[bar-1][num+4] + tmp[bar][num+3]; 
   }
   if(mode == 0) return(tmp[bar][num+4]);
   if(mode == 1) return(tmp[bar][num]);
   if(mode == 2) return(tmp[bar][num+2]);
   if(mode == 3) return(tmp[bar][num+4]);
}


double SMA(double array[],int per,int bar)
{
   double Sum = 0;
   for(int i = 0;i < per;i++) Sum += array[bar-i];
   
   return(Sum/per);
}                

double HeikenAshi(int tf,int price,int bar)
{ 
   if(bar == iBars(NULL,TimeFrame)- 1) 
   {
   haClose[bar] = iClose(NULL,tf,bar);
   haOpen[bar]  = iOpen(NULL,tf,bar);
   haHigh[bar]  = iHigh(NULL,tf,bar);
   haLow[bar]   = iLow(NULL,tf,bar);
   }
   else
   {
   haClose[bar] = (iOpen(NULL,tf,bar)+iHigh(NULL,tf,bar)+iLow(NULL,tf,bar)+iClose(NULL,tf,bar))/4;
   haOpen[bar]  = (haOpen[bar+1]+haClose[bar+1])/2;
   haHigh[bar]  = MathMax(iHigh(NULL,tf,bar),MathMax(haOpen[bar], haClose[bar]));
   haLow[bar]   = MathMin(iLow(NULL,tf,bar),MathMin(haOpen[bar], haClose[bar]));
   }
   
   switch(price)
   {
   case 0: return(haClose[bar]);break;
   case 1: return(haOpen[bar]);break;
   case 2: return(haHigh[bar]);break;
   case 3: return(haLow[bar]);break;
   }
}     

